summary refs log tree commit diff
path: root/ci
diff options
context:
space:
mode:
authorDavid Robertson <david.m.robertson1@gmail.com>2021-08-10 13:11:43 +0100
committerDavid Robertson <david.m.robertson1@gmail.com>2021-08-10 16:38:13 +0100
commit58e5da5aa06ee4dc1ad5b2774e7bcd4eb9911a70 (patch)
tree1181b69d0d8dad6c8a72787529da2c64764cfb96 /ci
parentRemove unused BUILDKITE_BRANCH env var (diff)
downloadsynapse-58e5da5aa06ee4dc1ad5b2774e7bcd4eb9911a70.tar.xz
Remove buildkite from portdb CI tests
Diffstat (limited to 'ci')
-rw-r--r--ci/postgres-config.yaml19
-rwxr-xr-xci/scripts/postgres_exec.py31
-rwxr-xr-xci/scripts/test_synapse_port_db.sh57
-rw-r--r--ci/sqlite-config.yaml16
4 files changed, 123 insertions, 0 deletions
diff --git a/ci/postgres-config.yaml b/ci/postgres-config.yaml
new file mode 100644
index 0000000000..511fef495d
--- /dev/null
+++ b/ci/postgres-config.yaml
@@ -0,0 +1,19 @@
+# Configuration file used for testing the 'synapse_port_db' script.
+# Tells the script to connect to the postgresql database that will be available in the
+# CI's Docker setup at the point where this file is considered.
+server_name: "localhost:8800"
+
+signing_key_path: "ci/test.signing.key"
+
+report_stats: false
+
+database:
+  name: "psycopg2"
+  args:
+    user: postgres
+    host: localhost
+    password: postgres
+    database: synapse
+
+# Suppress the key server warning.
+trusted_key_servers: []
diff --git a/ci/scripts/postgres_exec.py b/ci/scripts/postgres_exec.py
new file mode 100755
index 0000000000..0f39a336d5
--- /dev/null
+++ b/ci/scripts/postgres_exec.py
@@ -0,0 +1,31 @@
+#!/usr/bin/env python
+# Copyright 2019 The Matrix.org Foundation C.I.C.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+import sys
+
+import psycopg2
+
+# a very simple replacment for `psql`, to make up for the lack of the postgres client
+# libraries in the synapse docker image.
+
+# We use "postgres" as a database because it's bound to exist and the "synapse" one
+# doesn't exist yet.
+db_conn = psycopg2.connect(
+    user="postgres", host="localhost", password="postgres", dbname="postgres"
+)
+db_conn.autocommit = True
+cur = db_conn.cursor()
+for c in sys.argv[1:]:
+    cur.execute(c)
diff --git a/ci/scripts/test_synapse_port_db.sh b/ci/scripts/test_synapse_port_db.sh
new file mode 100755
index 0000000000..9ee0ad42fc
--- /dev/null
+++ b/ci/scripts/test_synapse_port_db.sh
@@ -0,0 +1,57 @@
+#!/usr/bin/env bash
+#
+# Test script for 'synapse_port_db'.
+#   - sets up synapse and deps
+#   - runs the port script on a prepopulated test sqlite db
+#   - also runs it against an new sqlite db
+
+
+set -xe
+cd `dirname $0`/../..
+
+echo "--- Install dependencies"
+
+# Install dependencies for this test.
+pip install psycopg2 coverage coverage-enable-subprocess
+
+# Install Synapse itself. This won't update any libraries.
+pip install -e .
+
+echo "--- Generate the signing key"
+
+# Generate the server's signing key.
+python -m synapse.app.homeserver --generate-keys -c ci/sqlite-config.yaml
+
+echo "--- Prepare test database"
+
+# Make sure the SQLite3 database is using the latest schema and has no pending background update.
+scripts-dev/update_database --database-config ci/sqlite-config.yaml
+
+# Create the PostgreSQL database.
+./ci/scripts/postgres_exec.py "CREATE DATABASE synapse"
+
+echo "+++ Run synapse_port_db against test database"
+coverage run scripts/synapse_port_db --sqlite-database ci/test_db.db --postgres-config ci/postgres-config.yaml
+
+# We should be able to run twice against the same database.
+echo "+++ Run synapse_port_db a second time"
+coverage run scripts/synapse_port_db --sqlite-database ci/test_db.db --postgres-config ci/postgres-config.yaml
+
+#####
+
+# Now do the same again, on an empty database.
+
+echo "--- Prepare empty SQLite database"
+
+# we do this by deleting the sqlite db, and then doing the same again.
+rm ci/test_db.db
+
+scripts-dev/update_database --database-config ci/sqlite-config.yaml
+
+# re-create the PostgreSQL database.
+./ci/scripts/postgres_exec.py \
+  "DROP DATABASE synapse" \
+  "CREATE DATABASE synapse"
+
+echo "+++ Run synapse_port_db against empty database"
+coverage run scripts/synapse_port_db --sqlite-database ci/test_db.db --postgres-config ci/postgres-config.yaml
diff --git a/ci/sqlite-config.yaml b/ci/sqlite-config.yaml
new file mode 100644
index 0000000000..fd5a1c1451
--- /dev/null
+++ b/ci/sqlite-config.yaml
@@ -0,0 +1,16 @@
+# Configuration file used for testing the 'synapse_port_db' script.
+# Tells the 'update_database' script to connect to the test SQLite database to upgrade its
+# schema and run background updates on it.
+server_name: "localhost:8800"
+
+signing_key_path: "ci/test.signing.key"
+
+report_stats: false
+
+database:
+  name: "sqlite3"
+  args:
+    database: "ci/test_db.db"
+
+# Suppress the key server warning.
+trusted_key_servers: []